﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart.Styles;
using Steema.TeeChart;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            tChart1.Draw();
        }
        private void tChart1_AfterDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {

            foreach (Series series in (sender as TChart).Series)
            {
                if ((series as Steema.TeeChart.Styles.Pie) != null)
                {
                    Rectangle[] MarksOfPie = new Rectangle[series.Marks.Positions.Count];
                    int circleXCenter = (series as Steema.TeeChart.Styles.Pie).CircleXCenter;
                    int circleYCenter = (series as Steema.TeeChart.Styles.Pie).CircleYCenter;
                    int pieWidth = (series as Steema.TeeChart.Styles.Pie).CircleWidth;
                    int pieHeight = (series as Steema.TeeChart.Styles.Pie).CircleHeight;

                    for (int i = 0; i < series.Marks.Positions.Count; i++)
                    {
                        MarksOfPie[i].X = series.Marks.Positions[i].LeftTop.X;
                        MarksOfPie[i].Y = series.Marks.Positions[i].LeftTop.Y;
                        MarksOfPie[i].Width = series.Marks.Positions[i].Width;
                        MarksOfPie[i].Height = series.Marks.Positions[i].Height;
                    }

                    int NumOfLeftT = 0;
                    int NumOfRightT = 0;
                    int MaxXLeft = 0;
                    int MaxXRight = 0;
                    int NumOfLeftB = 0;
                    int NumOfRightB = 0;

                    for (int i = 0; i < series.Marks.Positions.Count; i++)
                    {
                        if (series.Marks.Positions[i].ArrowFrom.X > circleXCenter)
                        {
                            if (MaxXRight < MarksOfPie[i].X)
                            {
                                MaxXRight = MarksOfPie[i].X;

                            }
                            if (series.Marks.Positions[i].ArrowFrom.Y > circleYCenter)
                            {

                                NumOfRightB += 1;

                            }
                            else
                            {
                                NumOfRightT += 1;
                            }

                        }
                        else
                        {

                            if (MaxXLeft > MarksOfPie[i].X)
                            {
                                MaxXLeft = MarksOfPie[i].X + MarksOfPie[i].Width;
                            }

                            if (series.Marks.Positions[i].ArrowFrom.Y > circleYCenter)
                            {

                                NumOfLeftB += 1;

                            }
                            else
                            {
                                NumOfLeftT += 1;
                            }

                        }

                    }
                    int MarkMaxWidth = 0;
                    for (int i = 0; i < series.Marks.Positions.Count; i++)
                    {
                        if (series.Marks.Positions[i].ArrowFrom.X < circleXCenter)
                        {
                            if (MarksOfPie[i].Width > MarkMaxWidth)
                            {
                                MarkMaxWidth = MarksOfPie[i].Width;
                            }
                        }
                    }

                    int DistanceOfMarksLeft = 0;
                    int DistanceOfMarksRight = 0;
                    int WidthOfMarkRight = 0;
                    int WidthOfMarkLeft = 0;
                    int CountLeftT = NumOfLeftT;
                    int CountRightT = NumOfRightT;

                    int CountLeftB = NumOfLeftB;
                    int CountRightB = NumOfRightB;

                    if ((NumOfLeftT + NumOfLeftB) != 0)
                    {
                        DistanceOfMarksLeft = ((sender as TChart).Height - 40 - MarksOfPie[0].Height * (NumOfLeftT + NumOfLeftB)) / (NumOfLeftT + NumOfLeftB);
                    }
                    if ((NumOfRightB + NumOfRightT) != 0)
                    {
                        DistanceOfMarksRight = ((sender as TChart).Height - 40 - MarksOfPie[0].Height * (NumOfRightB + NumOfRightT)) / (NumOfRightB + NumOfRightT);

                    }
                  for (int i = series.Marks.Positions.Count - 1; i >= 0; i--)
                    {
                        series.Marks.Positions[i].Custom = true;
                        if (series.Marks.Positions[i].ArrowFrom.X < circleXCenter)
                        {
                            if (series.Marks.Positions[i].ArrowFrom.Y > circleYCenter)
                            {
                                int LeftButtonY = 20 + ((CountLeftB + NumOfLeftT) * (DistanceOfMarksLeft + MarksOfPie[0].Height));

                                series.Marks.Positions[i].ArrowTo.X = MaxXLeft;
                                series.Marks.Positions[i].ArrowTo.Y = LeftButtonY;

                                series.Marks.Positions[i].LeftTop.X = MaxXLeft;
                                series.Marks.Positions[i].LeftTop.Y = LeftButtonY;
                                //(sender as TChart).Refresh();
                                //series.RefreshSeries();
                                CountLeftB--;
                            }

                            else
                            {
                                int LeftTopY = ((CountLeftT) * (DistanceOfMarksLeft + MarksOfPie[0].Height));
                                series.Marks.Positions[i].ArrowTo.X = MaxXLeft;
                                series.Marks.Positions[i].ArrowTo.Y = LeftTopY;

                                series.Marks.Positions[i].LeftTop.X = MaxXLeft;
                                series.Marks.Positions[i].LeftTop.Y = LeftTopY;
                              //(sender as TChart).Refresh();
                               // series.RefreshSeries();
                                CountLeftT--;

                            }
                        }

                        else
                        {
                            if (series.Marks.Positions[i].ArrowFrom.Y > circleYCenter)
                            {
                                int RightButtonY = 20 + ((NumOfRightT + NumOfRightB - CountRightB) * (DistanceOfMarksRight + MarksOfPie[0].Height));
                                series.Marks.Positions[i].ArrowTo.X = MaxXRight;
                                series.Marks.Positions[i].ArrowTo.Y = RightButtonY;

                                series.Marks.Positions[i].LeftTop.X = MaxXRight;
                                series.Marks.Positions[i].LeftTop.Y = RightButtonY;
                               //(sender as TChart).Refresh();
                              //  series.RefreshSeries();
                                CountRightB--;

                            }
                            else
                            {
                                int RightTopY = 20 + ((NumOfRightT - CountRightT) * (DistanceOfMarksRight + MarksOfPie[0].Height));

                                series.Marks.Positions[i].ArrowTo.X = MaxXRight;
                                series.Marks.Positions[i].ArrowTo.Y = RightTopY;

                                series.Marks.Positions[i].LeftTop.X = MaxXRight;
                                series.Marks.Positions[i].LeftTop.Y = RightTopY;
                               //(sender as TChart).Refresh();
                             //   series.RefreshSeries();
                                CountRightT--;

                            }

                        }
                    }

                    for (int i = 0; i < series.Marks.Positions.Count; i++)
                    {
                        MarksOfPie[i].X = series.Marks.Positions[i].LeftTop.X;
                        MarksOfPie[i].Y = series.Marks.Positions[i].LeftTop.Y;
                        MarksOfPie[i].Width = series.Marks.Positions[i].Width;
                        MarksOfPie[i].Height = series.Marks.Positions[i].Height;
                    }
                    int NumLeftC = 0;
                    int NumRightC = 0;
                    for (int i = 0; i < series.Marks.Positions.Count; i++)
                    {
                        if (series.Marks.Positions[i].ArrowFrom.X < circleXCenter)
                        {
                            if (series.Marks.Positions[i].ArrowTo.Y > circleYCenter - pieHeight / 2 && series.Marks.Positions[i].ArrowTo.Y < circleYCenter + pieHeight / 2)
                            {
                                NumLeftC++;
                            }

                        }
                        else
                        {
                            if (series.Marks.Positions[i].ArrowTo.Y > circleYCenter - pieHeight / 2 && series.Marks.Positions[i].ArrowTo.Y < circleYCenter + pieHeight / 2)
                            {
                                NumRightC++;
                            }
                        }

                    }
                    int CountLeftC = NumLeftC;
                    int CountRightC = NumRightC;

                    if (NumLeftC != 0)
                    {
                        WidthOfMarkLeft = (circleXCenter - pieWidth / 2 - MaxXLeft - MarkMaxWidth) / NumLeftC;
                    }

                    if (NumOfRightT != 0)
                    {
                        WidthOfMarkRight = (MaxXRight - circleXCenter - pieWidth / 2) / NumRightC;
                    }

                    CountRightT = NumOfRightT;
                    CountLeftT = NumOfLeftT;
                    for (int i = 0; i < series.Marks.Positions.Count; i++)
                    {
                        int arrowstartX = series.Marks.Positions[i].ArrowFrom.X;
                        int arrowstartY = series.Marks.Positions[i].ArrowFrom.Y;
                        int MarksX = series.Marks.Positions[i].ArrowTo.X;
                        int MarksY = series.Marks.Positions[i].ArrowTo.Y;


                        if (MarksX > circleXCenter)
                        {
                            if (MarksY < circleYCenter - pieHeight / 2)
                            {

                                g.Line(new Point(arrowstartX, arrowstartY), new Point(arrowstartX, series.Marks.Positions[i].LeftTop.Y));
                                g.Line(new Point(arrowstartX, series.Marks.Positions[i].LeftTop.Y), new Point(MarksX, MarksY));


                            }
                            else if (MarksY > circleYCenter - pieHeight / 2 && MarksY < circleYCenter + pieHeight / 2)
                            {
                                
                                g.Line(new Point(arrowstartX, arrowstartY), new Point(MarksX, MarksY));

                               
                            }
                            else
                            {
                                g.Line(new Point(arrowstartX, arrowstartY), new Point(arrowstartX, MarksY));
                                g.Line(new Point(arrowstartX, MarksY), new Point(MarksX, MarksY));

                            }
                        }
                        else
                        {
                            if (MarksY < circleYCenter - pieHeight / 2)
                            {
                               
                                g.Line(new Point(arrowstartX, arrowstartY), new Point(arrowstartX, series.Marks.Positions[i].LeftTop.Y));
                                g.Line(new Point(arrowstartX, series.Marks.Positions[i].LeftTop.Y), new Point(MarksX + MarksOfPie[i].Width, MarksY));

                            }

                            else if (MarksY > circleYCenter - pieHeight / 2 && MarksY < circleYCenter + pieHeight / 2)
                            {
                                g.Line(new Point(arrowstartX, arrowstartY), new Point(MarksX + MarksOfPie[i].Width, MarksY));
                             }
                            else
                            {
                               
                                g.Line(new Point(arrowstartX, arrowstartY), new Point(arrowstartX, MarksY));
                                g.Line(new Point(arrowstartX, MarksY), new Point(MarksX + MarksOfPie[i].Width, MarksY));
                            }

                        }

                    }
                }
            }
        }
    }
}
